package tech.krave.twilio_chat_plugin

import com.twilio.chat.ListenerException
import io.flutter.plugin.common.EventChannel.EventSink

open class BaseListener {
    var events: EventSink? = null

    private fun exceptionToMap(e: ListenerException?): Map<String, Any?>? {
        if (e == null)
            return null
        return mapOf("message" to e.message)
    }

    protected fun sendEvent(name: String, data: Any, e: ListenerException? = null) {
        val eventData = mapOf("name" to name, "data" to data, "error" to exceptionToMap(e))
        events?.success(eventData)
    }
}
