import 'package:flutter/material.dart';
import 'package:twilio_chat_plugin_example/ui/round_input.dart';

class SendMessageBar extends StatefulWidget {
  final ValueChanged<String> _handleSubmitted;
  final bool _isJoined;
  final Function _handleJoinChannel;

  SendMessageBar(
      this._handleSubmitted, this._isJoined, this._handleJoinChannel);

  @override
  _SendMessageBarState createState() => _SendMessageBarState();
}

class _SendMessageBarState extends State<SendMessageBar> {
  final _textController = TextEditingController();

  @override
  void initState() {
    super.initState();
  }

  _handleSubmittedLocal() {
    final text = _textController.text;

    // deal with local first
    _textController.clear();
    // deal with parent later
    widget._handleSubmitted(text);
  }

  void _handleChange(String text) {
    setState(() {
//      _showMic = text.length == 0;
    });
  }

  @override
  Widget build(BuildContext context) {
    return widget._isJoined
        ? Container(
            padding: EdgeInsets.symmetric(vertical: 8.0),
            child: Row(
              children: <Widget>[
                Expanded(
                  child: RoundInput(
                    textController: _textController,
                    handleSubmitted: (String text) {
                      _handleSubmittedLocal();
                    },
                    handleChange: _handleChange,
                  ),
                ),
                SizedBox(
                  width: 5.0,
                ),
                GestureDetector(
                  onTap: _handleSubmittedLocal,
                  child: CircleAvatar(
                    child: Icon(
                      Icons.send,
                      size: 16,
                    ),
                  ),
                ),
              ],
            ),
          )
        : Container(
            color: Colors.white,
            margin: EdgeInsets.only(bottom: 20),
            child: Row(
              children: <Widget>[
                MaterialButton(
                  child: Text('Join the channel'),
                  onPressed: () {
                    widget._handleJoinChannel();
                  },
                )
              ],
            ),
          );
  }
}
