#
# To learn more about a Podspec see http://guides.cocoapods.org/syntax/podspec.html.
# Run `pod lib lint twilio_chat_plugin.podspec' to validate before publishing.
#
require "yaml"
require "ostruct"

project = OpenStruct.new YAML.load_file("../pubspec.yaml")
Pod::Spec.new do |s|
  s.name             =  project.name
  s.version          =  project.version
  s.summary          =  'Twilio Programmable Chat Flutter Package'
  s.description      =  project.description

  s.homepage         = project.homepage
  s.license          = { :file => '../LICENSE', :type => 'MIT' }
  s.author           = { 'Krave Technology' => 'austin@krave.tech' }
  s.source           = { :path => '.' }
  s.source_files = 'Classes/**/*'

  s.dependency      'Flutter'
  s.dependency      'TwilioChatClient', '~> 3.0'

  s.platform = :ios, '11.0'
  s.ios.deployment_target = '11.0'

  # Flutter.framework does not contain a i386 slice. Only x86_64 simulators are supported.
  s.pod_target_xcconfig = { 'DEFINES_MODULE' => 'YES', 'VALID_ARCHS[sdk=iphonesimulator*]' => 'x86_64' }
  s.swift_version = '5.0'
end
